
#include <windows.h>
//#include <ceddk.h>
#include <nkintr.h>
//#include <oalintr.h>
#include <pm.h>
#include "pmplatform.h"
#include "Pkfuncs.h"
#include "s2440.h"

#include "pwm.h"

static BOOL SetFeq(DWORD Feq)
{
	BOOL ret = FALSE;
	volatile IOPreg 	*s2440IOP = 0;
	volatile PWMreg		*s2440PWM = 0;
	do {
		s2440IOP = (volatile IOPreg *) VirtualAlloc(0,sizeof(IOPreg),MEM_RESERVE, PAGE_NOACCESS);
		if (s2440IOP == 0) {
			break;
		}
		s2440PWM = (volatile PWMreg *) VirtualAlloc(0,sizeof(PWMreg),MEM_RESERVE, PAGE_NOACCESS);
		if (s2440PWM == 0) {
			break;
		}

		if (!VirtualCopy((PVOID)s2440IOP,(PVOID)(IOP_BASE),sizeof(IOPreg),PAGE_READWRITE | PAGE_NOCACHE )) {
			break;
		}

		if (!VirtualCopy((PVOID)s2440PWM,(PVOID)(PWM_BASE),sizeof(PWMreg),PAGE_READWRITE | PAGE_NOCACHE )) {
			break;
		}

		ret = TRUE;
		if (Feq == 0) {
			// STOP
			s2440PWM->rTCON &= ~1;
			s2440IOP->rGPBCON = (s2440IOP->rGPBCON & ~(0x3<<0x0)) | 0x1;
			s2440IOP->rGPBDAT &= ~1;
		} else {
			// Change

			s2440IOP->rGPBCON = (s2440IOP->rGPBCON & ~(0x3<<0x0)) | 0x2;

			s2440PWM->rTCFG0 = s2440PWM->rTCFG0 & ~0xFF | 49;
			s2440PWM->rTCFG1 = s2440PWM->rTCFG1 & ~0xF  | 0x3;
			s2440PWM->rTCNTB0 = (1000 * 1000) / 16 / Feq;
			s2440PWM->rTCMPB0 = (1000 * 1000) / 16 / Feq / 2;
			s2440PWM->rTCON = s2440PWM->rTCON & ~0x1F | 0x0b;
			s2440PWM->rTCON &= ~2;

		}
	} while (0);

	//RETAILMSG(1,(TEXT("Set FEQ = %u, ret = %d\r\n"), Feq, ret));

	if (s2440IOP) {
		VirtualFree((void*)s2440IOP, sizeof(IOPreg), MEM_RELEASE);
		s2440IOP = 0;
	}
	if (s2440PWM) {
		VirtualFree((void*)s2440PWM, sizeof(PWMreg), MEM_RELEASE);
		s2440PWM = 0;
	}

	return ret;
}




BOOL WINAPI  
DllEntry(HANDLE	hinstDLL, 
			DWORD dwReason, 
			LPVOID  Reserved/* lpvReserved */)
{
	switch(dwReason)
	{
	case DLL_PROCESS_ATTACH:
		DEBUGREGISTER((HINSTANCE)hinstDLL);
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		break;
#ifdef UNDER_CE
	case DLL_PROCESS_EXITING:
		break;
	case DLL_SYSTEM_STARTED:
		break;
#endif
	}

	return TRUE;
}


BOOL PWM_Deinit(DWORD hDeviceContext)
{
	BOOL bRet = TRUE;
	
	return TRUE;
} 









DWORD PWM_Init(DWORD dwContext)
{
	return TRUE;
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
BOOL PWM_IOControl(DWORD hOpenContext, 
				   DWORD dwCode, 
				   PBYTE pBufIn, 
				   DWORD dwLenIn, 
				   PBYTE pBufOut, 
				   DWORD dwLenOut, 
				   PDWORD pdwActualOut)
{
 
  BOOL ret = FALSE;
  switch(dwCode) {
  case PWM_STOP:
  	ret = SetFeq(0);
  	break;
  case PWM_SET_FEQ:
  	{
  		DWORD feq;
  		if (dwLenIn != sizeof feq) {
  			break;
  		}
  		feq = * (DWORD *)pBufIn;
  		ret = SetFeq(feq);
  	}
  	break;
 } 			   
	return TRUE;
} 

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
DWORD PWM_Open(DWORD hDeviceContext, DWORD AccessCode, DWORD ShareMode)
{
	SetFeq(0);
	return TRUE;
} 

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
BOOL PWM_Close(DWORD hOpenContext)
{
	SetFeq(0);
	return TRUE;
} 

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void PWM_PowerDown(DWORD hDeviceContext)
{
	SetFeq(0);
} 

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
void PWM_PowerUp(DWORD hDeviceContext)
{
	RETAILMSG(1,(TEXT("PWM: PowerUp\r\n")));
	SetFeq(0);
} 

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
DWORD PWM_Read(DWORD hOpenContext, LPVOID pBuffer, DWORD Count)
{
	return TRUE;
} 

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
DWORD PWM_Seek(DWORD hOpenContext, long Amount, DWORD Type)
{
	return 0;
} 

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
DWORD PWM_Write(DWORD hOpenContext, LPCVOID pSourceBytes, DWORD NumberOfBytes)
{
	return 0;
}




